public class DList implements DListInt{
    protected int size;
    protected Nodo head, trail;

    /**costruttore che crea una lista vuota. */

    public DList() {
        head = new Nodo(null,null,null);
	trail = new Nodo(null,head,null);
	head.setNext(trail);
    }

   /**restituisce il numero di elementi nella lista */

    public int size() {
        return size;
    }

   /**restituisce un valore che indica se la lista e' vuota */

    public boolean isEmpty() {
        return (size == 0);
    }

   /**restituisce il primo nodo della lista */

    public Nodo getFirst() throws IllegalStateException {
	if (isEmpty()) throw new IllegalStateException("Lista vuota");
	return head.getNext();
    }

    /**restituisce l'ultimo nodo della lista */

    public Nodo getLast() throws IllegalStateException {
	if (isEmpty()) throw new IllegalStateException("Lista vuota");
	return trail.getPrev();
    }
    
   /** Restituisce il nodo che precede il nodo v; si verifica
     * un errore se v e' head */
    public Nodo getPrev(Nodo v) throws IllegalArgumentException {
	if (v == head) throw new IllegalArgumentException("Inizio lista");
	return v.getPrev();
    }

    /** Restituisce il nodo dopo il nodo v; si verifica un errore  
     * se v e' trail */
    public Nodo getNext(Nodo v) throws IllegalArgumentException {
	if (v == trail) throw new IllegalArgumentException("Fine lista");
	return v.getNext();
    }

    /** Inserisce il nodo v all'inizio della lista e incrementa 
     * il numero di elementi della lista */
    public void addFirst(Nodo v){
	Nodo w = getNext(head);
	w.setPrev(v);
	v.setPrev(head);
	v.setNext(head.getNext());
	head.setNext(v);
	size++;
    }

    /** Inserisce il nodo v alla fine della lista e incrementa 
     * di uno il numero di elementi della lista */
    public void addLast(Nodo v) {
	Nodo u = getPrev(trail);
	v.setNext(trail);
	v.setPrev(u);
	trail.setPrev(v);
	u.setNext(v);
	size++;
    }

    /** Rimuove il nodo v dalla lista e decrementa 
     * di uno il numero di elementi della lista */
    public void remove(Nodo v){
	Nodo u = getPrev(v);
	Nodo w = getNext(v);
	w.setPrev(u);
	u.setNext(w);
	v.setPrev(null);
	v.setNext(null);
	size--;
    }
}
